/*
 *  SGKeyDumper
 *
 *  Copyright (C) 2014 qwikrazor87
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <pspkernel.h>
#include <pspsysmem_kernel.h>
#include <psputilsforkernel.h>
#include <string.h>
#include "lib.h"

PSP_MODULE_INFO("SGKeyDumper", PSP_MODULE_KERNEL, 0, 5);
PSP_HEAP_SIZE_KB(0);

u32 _sceUtilitySavedataInitStart, _sub;

void qwikDump(u32 a0, u32 a1)
{
	u32 k1 = pspSdkSetK1(0);

	char SavePath[128];
	memset((void *)SavePath, 0, sizeof(SavePath));

	strcpy(SavePath, "ms0:/PSP/SAVEPLAIN/");

	strcat(SavePath, (char *)(a1 + 0x3C)); //game ID

	if (strcmp((char *)(a1 + 0x4C), "<>") != 0)
		strcat(SavePath, (char *)(a1 + 0x4C)); //save ID

	sceIoMkdir(SavePath, 0777);

	strcat(SavePath, "/");
	strcat(SavePath, (char *)(a1 + 0x3C)); //game ID
	strcat(SavePath, ".bin");

	SceUID fd = sceIoOpen(SavePath, PSP_O_CREAT | PSP_O_WRONLY | PSP_O_TRUNC, 0777);

	sceIoWrite(fd, (const void *)(a1 + ((*(u32*)a1) - 0x24)), 16); //end of savedata struct - 36

	sceIoClose(fd);

	pspSdkSetK1(k1);

	void (* _sub_)(u32, u32) = (void *)_sub;
	_sub_(a0, a1);
}

int thread_start(SceSize args, void *argp)
{
	int (* _sceKernelGetSystemStatus)(void) = (void *)FindExport("sceSystemMemoryManager", "SysMemForKernel", 0x36C503A9);

	//wait until the system returns booted status
	while (_sceKernelGetSystemStatus() != 0x20000)
		sceKernelDelayThread(1000);

	_sceUtilitySavedataInitStart = FindExport("sceUtility_Driver", "sceUtility", 0x50C4CD57);

	if (_sceUtilitySavedataInitStart) {
		//get the sub address called by sceUtilitySavedataInitStart
		_sub = ((*(u32*)(_sceUtilitySavedataInitStart + 0x18) & 0x03FFFFFF) << 2) | 0x80000000;

		_sw(MAKE_CALL(qwikDump), _sceUtilitySavedataInitStart + 0x18);

		sceKernelDcacheWritebackInvalidateAll();
		sceKernelIcacheInvalidateAll();

		sceIoMkdir("ms0:/PSP/SAVEPLAIN", 0777);
	}

	return 0;
}

int module_start(SceSize args, void *argp)
{
	SceUID thid = sceKernelCreateThread("SGKeyDumper", thread_start, 0x22, 0x2000, 0, NULL);

	if (thid >= 0)
		sceKernelStartThread(thid, args, argp);

	return 0;
}

int module_stop(SceSize args, void *argp)
{
	return 0;
}
